<template>
    <div ref="field-file"
        :style="{'max-width': `${maxWidth}px`}"
        class="field-file"
        @click.stop="$refs.file.click()"
        @dragover.prevent.stop
        @dragenter.prevent.stop
        @drop.stop.prevent="dropFile"
    >
        <div v-if="header" class="field-file__header">{{ header }}</div>
        <div class="field-file__content-wrapper">
            <div class="field-file__content">
                <div class="field-file__icon-block" :style="{'background-image': 'url('+ `${image || ''}` +')'}">
                    <base-svg-icon  v-show="!image"
                                    :class="['field-file__icon', {'field-file__icon--loading': loading}]"
                                    id="disk"
                                    width="56"
                                    height="56"
                                    viewBox="0 0 56 56"
                    />
                    <div v-show="loading" class="field-file__loader">
                        <div class="field-file__percent">{{ receivePercentageLoading }}%</div>
                        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 85 85">
                            <circle cx="42.5" cy="42.5" r="40.5" fill="none" stroke="#FFA552" :stroke-dasharray="dasharray" stroke-width="3"></circle>
                        </svg>
                    </div>
                </div>
                <div class="field-file__text-block">
                    <div class="field-file__text-block-head">{{ headerField }}</div>
                    <div v-if="(!file || loading) && !image">
                        <div v-if="error" class="field-file__text-block-error">{{ error }}</div>
                        <div v-else-if="!error && loading" class="field-file__text-block-loading">Загружается...</div>
                        <div v-else class="field-file__text-block-description">Выберите файл или перетащите его сюда</div>
                        <div class="field-file__text-block-condition">PDF, JPEG, PNG или TIFF до 40 МБ</div>
                    </div>
                    <div v-else>
                        <div class="field-file__text-block-file-name">{{ file.name }}</div>
                        <div class="field-file__text-block-description">Заменить файл</div>
                    </div>
                </div>
                <input  ref="file"
                        type="file"
                        class="field-file__input"
                        @change="selectFile"
                >
            </div>
        </div>
    </div>
</template>

<script>
export default {
    name: 'base-field-file-image',
    props: {
        value: [Object, File],
        maxWidth: Number,
        header: {
            type: String,
            default: ''
        },
        headerField: {
            type: String,
            default: ''
        },
        maxSize: {
            type: Number,
            default: 40000000
        }
    },
    data() {
        return {
            file: null,
            image: null,
            loaded: 0,
            loading: false,
            availableTypes: [
                'pds',
                'jpeg',
                'png',
                'tiff'
            ],
            error: ''
        };
    },
    watch: {
        value(val) {
            if (val === null && this.file) {
                this.setDefaultValues();
                this.$refs.file.value = '';
            }
        }
    },
    computed: {
        onePercent() {
            return this.file && this.file.size ? parseInt(this.file.size / 100) : 0;
        },
        receivePercentageLoading() {
            return this.file && this.onePercent ? parseInt(this.loaded / this.onePercent) : 0;
        },
        dasharray() {
            const max = 40.5 * 2 * Math.PI;
            return `${this.receivePercentageLoading / 100 * max} ${max}`;
        }
    },
    methods: {
        selectFile(e) {
            const [file] = e.target.files;
            this.upload(file);
        },
        dropFile(e) {
            const [file] = e.dataTransfer.files;
            this.upload(file);
        },
        upload(file) {
            this.error = '';
            if (file && this.checkValideFile(file)) {
                this.setDefaultValues();
                this.setProperyFile(file);
                this.loadFile(file);
                return;
            }
            this.$emit('input', null);
            this.setDefaultValues();
        },
        setProperyFile(file) {
            this.file = Object.assign({
                name: file.name,
                size: file.size,
                type: file.type
            });
        },
        loadFile(file) {
            this.loading = !this.loading;
            const reader = new FileReader();

            reader.onprogress = e => {
                if (e.lengthComputable) this.loaded = e.loaded;
            };

            reader.onload = e => {
                this.image = e.target.result;
                this.$emit('input', file);
                this.loading = !this.loading;
            };

            reader.onerror = e => {
                this.loading = !this.loading;
            };

            reader.readAsDataURL(file);
        },
        setDefaultValues() {
            this.file = null;
            this.image = null;
            this.loaded = 0;
        },
        checkValideFile(file) {
            const [type, expansion] = file.type.split('/');
            const size = file.size;

            if (!type || !expansion || !this.availableTypes.includes(expansion)) {
                this.error = 'Некорретный формат файла. Проверьте требования ниже';
                return false;
            }

            if (size > this.maxSize) {
                this.error = 'Некорретный вес файла. Проверьте требования ниже';
                return false;
            }

            return true;
        }
    }
};
</script>

<style lang="sass">
@import "~assets/blocks/fields/field-file/index"
</style>
